require 'json'

module StructToJSON

  def to_json
    to_h.to_json
  end

  def self.included(base)
    base.instance_eval do
      alias_method :to_s, :to_json
    end
  end

end

require 'active_support/inflector'

module StructToIGLU

  IGLU_SCHEMA_URI = 'iglu:%{company}/%{event}/jsonschema/%{version}'.freeze

  def schema(company ='uk.co.simplybusiness', version = '1-0-0')
    format(IGLU_SCHEMA_URI,
      company: company,
      version: version,
      # this assumes `type` is a (namespaced) Ruby class name
      # 'Idiophone::Events::JoinRequested' > 'join_requested'
      event: self.type.split('::').last.underscore,
    )
  end

  def to_iglu
    {
      schema: self.schema,
      data:   self.to_h,
    }
  end

end
