require 'English'

lib = File.expand_path(__dir__)
$LOAD_PATH.unshift(lib) unless $LOAD_PATH.include?(lib)

require "kafka_lite/version"

# TODO replace with Rinda ??
# https://ruby-doc.org/stdlib-2.1.1/libdoc/rinda/rdoc

require 'drb/drb'
DRb.start_service

module TrRMIte

    DIRECTORY = case RUBY_PLATFORM
      when /darwin/i
        require 'tmpdir'
        Dir.tmpdir
      when /linux/i
        File.join(Dir.home, 'kafka_lite')
      else nil
    end

    raise "Unsupported platform: #{RUBY_PLATFORM}" unless DIRECTORY

    OFFSET_STORE = File.join(DIRECTORY, 'kafka_lite.offset_store')
    EVENT_LOG    = File.join(DIRECTORY, 'kafka_lite.event_log')

    class OutOfSequence < StandardError ; end
    class WrongTopic < StandardError ; end

end

module Kafka
  module Lite

    PRODUCER_QUEUE    = DRbObject.new_with_uri('druby://127.0.0.1:1111')
    CONSUMER_REGISTRY = DRbObject.new_with_uri('druby://127.0.0.1:9999')

    module_function

    def send event
      deliver_message event.to_json
    end

    def deliver_message msg
      PRODUCER_QUEUE.push msg
    end

  end
end

require 'active_support/core_ext/hash/keys'

require 'ext/argv'
require 'ext/struct'
require 'ext/string'
require 'ext/commify'
require 'ext/numeric'

require 'kafka_lite/event'
require 'kafka_lite/consumer'
require 'kafka_lite/producer'

require 'kafka_lite/consumers'
require 'kafka_lite/producers'
