class Producer

  attr_reader :events

  def initialize
    @events = Enumerator.new do |yielder|
      loop do
        if (event = next_event)
          yielder << event
        else
          raise StopIteration
        end
      end
    end
  end

  private

  def next_event
    raise 'SubclassResponsibility'
  end

end

class ProxyProducer < Producer

  attr_reader :queue

  def initialize
    super
    @queue = Queue.new
  end

  private

  def next_event
    @queue.pop
  end

end
